﻿using System;
using TaleWorlds.Library;

namespace gunmod
{
	// Token: 0x02000007 RID: 7
	public static class vechelper
	{
		// Token: 0x06000040 RID: 64 RVA: 0x000032D8 File Offset: 0x000014D8
		public static bool isnumber(this string text)
		{
			if (text == null)
			{
				return false;
			}
			text = text.Trim();
			if (text.Length == 0)
			{
				return false;
			}
			for (int i = 0; i < text.Length; i++)
			{
				if (!text[i].isnumber())
				{
					return false;
				}
			}
			return true;
		}

		// Token: 0x06000041 RID: 65 RVA: 0x00003320 File Offset: 0x00001520
		public static bool isnumber(this char a)
		{
			char c = '0';
			for (int i = 0; i < 10; i++)
			{
				if ((int)a == (int)c + i)
				{
					return true;
				}
			}
			return a == '.';
		}

		// Token: 0x06000042 RID: 66 RVA: 0x00003350 File Offset: 0x00001550
		public static double Xmax(this Vector2[] vector2s)
		{
			double x = vector2s[0].X;
			foreach (Vector2 vector in vector2s)
			{
				if (vector.X > x)
				{
					x = vector.X;
				}
			}
			return x;
		}

		// Token: 0x06000043 RID: 67 RVA: 0x00003398 File Offset: 0x00001598
		public static double Ymax(this Vector2[] vector2s)
		{
			double y = vector2s[0].Y;
			foreach (Vector2 vector in vector2s)
			{
				if (vector.Y > y)
				{
					y = vector.Y;
				}
			}
			return y;
		}

		// Token: 0x06000044 RID: 68 RVA: 0x000033E0 File Offset: 0x000015E0
		public static double Xmin(this Vector2[] vector2s)
		{
			double x = vector2s[0].X;
			foreach (Vector2 vector in vector2s)
			{
				if (vector.X < x)
				{
					x = vector.X;
				}
			}
			return x;
		}

		// Token: 0x06000045 RID: 69 RVA: 0x00003428 File Offset: 0x00001628
		public static double Ymin(this Vector2[] vector2s)
		{
			double y = vector2s[0].Y;
			foreach (Vector2 vector in vector2s)
			{
				if (vector.Y < y)
				{
					y = vector.Y;
				}
			}
			return y;
		}

		// Token: 0x06000046 RID: 70 RVA: 0x00003470 File Offset: 0x00001670
		public static double angle(this Vector2 vector2)
		{
			if (vector2.X == 0.0)
			{
				if (vector2.Y == 0.0)
				{
					return 0.0;
				}
				if (vector2.Y > 0.0)
				{
					return 90.0;
				}
				return 270.0;
			}
			else
			{
				if (vector2.Y != 0.0)
				{
					return Math.Atan2(vector2.Y, vector2.X) / 3.141592653589793 * 180.0;
				}
				if (vector2.X > 0.0)
				{
					return 0.0;
				}
				return 180.0;
			}
		}

		// Token: 0x06000047 RID: 71 RVA: 0x00003530 File Offset: 0x00001730
		public static Vector2[] row(this Vector2[] points, double angle)
		{
			Vector2[] array = null;
			if (points != null)
			{
				array = new Vector2[points.Length];
				for (int i = 0; i < array.Length; i++)
				{
					array[i] = points[i].row(angle);
				}
			}
			return array;
		}

		// Token: 0x06000048 RID: 72 RVA: 0x00003570 File Offset: 0x00001770
		public static Vector2 row(this Vector2 point, double angle)
		{
			return new Vector2(point.value() * Math.Cos((angle + point.angle()) / 180.0 * 3.141592653589793), point.value() * Math.Sin((angle + point.angle()) / 180.0 * 3.141592653589793));
		}

		// Token: 0x06000049 RID: 73 RVA: 0x000035D4 File Offset: 0x000017D4
		public static Vector2 trans(this Vector2 vector2, double angle, double k)
		{
			return k * vector2.row(angle);
		}

		// Token: 0x0600004A RID: 74 RVA: 0x000035E4 File Offset: 0x000017E4
		public static Vector2[] trans(this Vector2[] vector2, double angle, double k)
		{
			Vector2[] array = new Vector2[vector2.Length];
			Vector2 vector3 = vector2[0];
			for (int i = 0; i < vector2.Length; i++)
			{
				Vector2 vector4 = vector3 + (vector2[i] - vector3).trans(angle, k);
				array[i] = vector4;
			}
			return array;
		}

		// Token: 0x0600004B RID: 75 RVA: 0x00003634 File Offset: 0x00001834
		public static Vector3[] trans(this Vector3[] vector3, double angle, double k)
		{
			Vector3[] array = new Vector3[vector3.Length];
			Vector2[] array2 = vector3.toVec2().trans(angle, k);
			for (int i = 0; i < vector3.Length; i++)
			{
				array[i] = new Vector3(array2[i].X, array2[i].Y, vector3[i].z);
			}
			return array;
		}

		// Token: 0x0600004C RID: 76 RVA: 0x00003698 File Offset: 0x00001898
		public static Vector2 zoom(this Vector2 vector2, Vector2 direction, double k)
		{
			direction = direction.nolrmalized();
			double num = vector2.product(direction);
			return vector2 - (num - num * k) * direction;
		}

		// Token: 0x0600004D RID: 77 RVA: 0x000036C8 File Offset: 0x000018C8
		public static bool issameside(this Vector2 vector2, Vector2 p, Vector2 l1, Vector2 l2)
		{
			Vector2 vector3 = l2 - l1;
			Vector2 vector4 = p - l1;
			Vector2 vector5 = vector2 - l1;
			return (vector3.angle() - vector4.angle()) * (vector3.angle() - vector5.angle()) >= 0.0;
		}

		// Token: 0x0600004E RID: 78 RVA: 0x00003716 File Offset: 0x00001916
		public static Vector2 dv2(this Vec2 vec)
		{
			return new Vector2((double)vec.x, (double)vec.y);
		}

		// Token: 0x0600004F RID: 79 RVA: 0x0000372C File Offset: 0x0000192C
		public static Vector2 c(this Vector2[] vecs)
		{
			Vector2 vector = new Vector2(0, 0);
			for (int i = 0; i < vecs.Length; i++)
			{
				vector += vecs[i];
			}
			return vector / (double)vecs.Length;
		}

		// Token: 0x06000050 RID: 80 RVA: 0x00003768 File Offset: 0x00001968
		public static bool isin(this Vector2 point, Vector2[] vectors)
		{
			Vector2 vector = vectors.c();
			for (int i = 0; i < vectors.Length - 1; i++)
			{
				if ((vectors[i] - vectors[i + 1]).value() != 0.0 && !vector.issameside(point, vectors[i], vectors[i + 1]))
				{
					return false;
				}
			}
			return (vectors[0] - vectors[vectors.Length - 1]).value() == 0.0 || vector.issameside(point, vectors[0], vectors[vectors.Length - 1]);
		}

		// Token: 0x06000051 RID: 81 RVA: 0x00003818 File Offset: 0x00001A18
		public static Vector2[] zoom(this Vector2[] vector2, Vector2 direction, double k)
		{
			Vector2[] array = new Vector2[vector2.Length];
			Vector2 vector3 = vector2[0];
			for (int i = 0; i < vector2.Length; i++)
			{
				array[i] = vector3 + (vector2[i] - vector3).zoom(direction, k);
			}
			return array;
		}

		// Token: 0x06000052 RID: 82 RVA: 0x00003868 File Offset: 0x00001A68
		public static Vector3[] zoom(this Vector3[] vector3, Vector2 direction, double k)
		{
			Vector3[] array = new Vector3[vector3.Length];
			Vector2[] array2 = vector3.toVec2().zoom(direction, k);
			for (int i = 0; i < vector3.Length; i++)
			{
				array[i] = new Vector3(array2[i].X, array2[i].Y, vector3[i].z);
			}
			return array;
		}

		// Token: 0x06000053 RID: 83 RVA: 0x000038CC File Offset: 0x00001ACC
		public static Vector2[] normalize(this Vector2[] vectors)
		{
			Vector2 b = vectors[0];
			Vector2[] array = new Vector2[vectors.Length];
			for (int i = 0; i < vectors.Length; i++)
			{
				array[i] = vectors[i] - b;
			}
			return array;
		}

		// Token: 0x06000054 RID: 84 RVA: 0x00003910 File Offset: 0x00001B10
		public static Vector2[] toVec2(this Vector3[] vector3s)
		{
			Vector2[] array = new Vector2[vector3s.Length];
			for (int i = 0; i < vector3s.Length; i++)
			{
				array[i] = new Vector2(vector3s[i].x, vector3s[i].y);
			}
			return array;
		}
	}
}
